<template>
    <div class="app-container">
        {{message}}
        <bus v-for="bus in buses" :key="bus.number" :bus="bus" :style="{ left: `${bus.x}px` }"></bus>
    </div>
</template>

<script>
import { of, interval, animationFrameScheduler } from 'rxjs';
import { map, tap, take, finalize, pairwise } from 'rxjs/operators';

import Bus from './Bus.vue';

class BusModel {
    constructor(id) {
        this.number = id;
        this.x = 0;
        this.speed = Math.random() * 0.1 + 0.05;
        this.direction = 1;
    }
}

export default {
    components: {
        Bus,
    },
    data() {
        return {
            message: 'Loading...',
            buses: [],
        };
    },
    created() {
        interval(1000).pipe(
            take(10),
            map(i => i + 1),
            tap(i => this.message = `Bus number ${i} starts its engine...`),
            tap(i => this.buses.push(new BusModel(i))),
            finalize(() => { 
                this.message = 'Vue RxJS Bus Ride!';
            }),
        ).subscribe();
        interval(0, animationFrameScheduler).pipe(
            map(i => Date.now()),
            pairwise(),
            map(pair => pair[1] - pair[0]),
            tap(timespan => this.buses.forEach(b =>  {
                b.x += b.speed * timespan * b.direction;
                const limit = 300;
                if (b.x > limit && b.direction == 1) b.direction = -1;
                if (b.x < -1 * limit && b.direction == -1) b.direction = 1;
            })),
        ).subscribe();
    },
}
</script>

<style>
html {
    font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;
}
body {
    margin: 20px
}
.app-container {
    text-align: center;
    overflow: hidden;
}
</style>
